"""
created_at_utc  : 2022-10-28T07:01:22Z
created_at_w3c  : 2022-10-28T15:01:22+08:00
PAIA-Desktop    : 2.4.1-competition-tn
MLGame          : 10.0.2
game            : pingpong
game_version    : 2.3.1
"""

import pickle
import os
import random

_E7_8E_A9_E5_AE_B6_E7_B7_A8_E8_99_9F = None
_E7_99_BC_E7_90_83_E4_BD_8D_E7_BD_AE = None
_E7_99_BC_E7_90_83_E6_96_B9_E5_90_91 = None
_E5_B9_B3_E5_8F_B0X_E5_BA_A7_E6_A8_99 = None
AI_E6_A8_A1_E5_9E_8B = None
_E9_A0_90_E6_B8_AC_E7_B5_90_E6_9E_9C = None
_E7_A7_BB_E5_8B_95_E6_96_B9_E5_90_91 = None


class MLPlay:
    def __init__(self, ai_name, *args, **kwargs):
        global _E7_8E_A9_E5_AE_B6_E7_B7_A8_E8_99_9F, _E7_99_BC_E7_90_83_E4_BD_8D_E7_BD_AE, _E7_99_BC_E7_90_83_E6_96_B9_E5_90_91, _E5_B9_B3_E5_8F_B0X_E5_BA_A7_E6_A8_99, AI_E6_A8_A1_E5_9E_8B, _E9_A0_90_E6_B8_AC_E7_B5_90_E6_9E_9C, _E7_A7_BB_E5_8B_95_E6_96_B9_E5_90_91
        _E7_8E_A9_E5_AE_B6_E7_B7_A8_E8_99_9F = ai_name
        if _E7_8E_A9_E5_AE_B6_E7_B7_A8_E8_99_9F == '1P':
            # 載入1P的AI模型
            with open(os.path.join(os.path.dirname(__file__), 'model_1P' + '.pickle'), 'rb') as f:
                AI_E6_A8_A1_E5_9E_8B = pickle.load(f)
        else:
            # 載入2P的AI模型
            with open(os.path.join(os.path.dirname(__file__), 'model_2P' + '.pickle'), 'rb') as f:
                AI_E6_A8_A1_E5_9E_8B = pickle.load(f)
        _E7_99_BC_E7_90_83_E4_BD_8D_E7_BD_AE = random.randint(0 + 20, 200 - 20)
        _E7_99_BC_E7_90_83_E6_96_B9_E5_90_91 = random.randint(1, 100) % 2
    def update(self, scene_info, keyboard=[], *args, **kwargs):
        global _E7_8E_A9_E5_AE_B6_E7_B7_A8_E8_99_9F, _E7_99_BC_E7_90_83_E4_BD_8D_E7_BD_AE, _E7_99_BC_E7_90_83_E6_96_B9_E5_90_91, _E5_B9_B3_E5_8F_B0X_E5_BA_A7_E6_A8_99, AI_E6_A8_A1_E5_9E_8B, _E9_A0_90_E6_B8_AC_E7_B5_90_E6_9E_9C, _E7_A7_BB_E5_8B_95_E6_96_B9_E5_90_91
        if scene_info['status'] != "GAME_ALIVE":
            return "RESET"
        if _E7_8E_A9_E5_AE_B6_E7_B7_A8_E8_99_9F == '1P':
            _E5_B9_B3_E5_8F_B0X_E5_BA_A7_E6_A8_99 = scene_info['platform_1P'][0]
        else:
            _E5_B9_B3_E5_8F_B0X_E5_BA_A7_E6_A8_99 = scene_info['platform_2P'][0]
        if not scene_info['ball_served']:
            while not (_E7_99_BC_E7_90_83_E4_BD_8D_E7_BD_AE - 30 <= _E5_B9_B3_E5_8F_B0X_E5_BA_A7_E6_A8_99 and _E5_B9_B3_E5_8F_B0X_E5_BA_A7_E6_A8_99 <= _E7_99_BC_E7_90_83_E4_BD_8D_E7_BD_AE - 10):
                if _E7_99_BC_E7_90_83_E4_BD_8D_E7_BD_AE < _E5_B9_B3_E5_8F_B0X_E5_BA_A7_E6_A8_99 + 40 / 2:
                    return "MOVE_LEFT"
                else:
                    return "MOVE_RIGHT"
            if _E7_99_BC_E7_90_83_E6_96_B9_E5_90_91 == 1:
                return "SERVE_TO_LEFT"
            else:
                return "SERVE_TO_RIGHT"
        else:
            # 所有的特徵資料必須跟收集的順序相同喔!!
            _E9_A0_90_E6_B8_AC_E7_B5_90_E6_9E_9C = AI_E6_A8_A1_E5_9E_8B.predict([[scene_info['ball'][0], scene_info['ball'][1], scene_info['ball_speed'][0], scene_info['ball_speed'][1], _E5_B9_B3_E5_8F_B0X_E5_BA_A7_E6_A8_99]]).tolist()
            _E7_A7_BB_E5_8B_95_E6_96_B9_E5_90_91 = _E9_A0_90_E6_B8_AC_E7_B5_90_E6_9E_9C[0]
            if _E7_A7_BB_E5_8B_95_E6_96_B9_E5_90_91 == 1:
                return "MOVE_LEFT"
            elif _E7_A7_BB_E5_8B_95_E6_96_B9_E5_90_91 == 2:
                return "MOVE_RIGHT"
            else:
                return "NONE"
    def reset(self):
        global _E7_8E_A9_E5_AE_B6_E7_B7_A8_E8_99_9F, _E7_99_BC_E7_90_83_E4_BD_8D_E7_BD_AE, _E7_99_BC_E7_90_83_E6_96_B9_E5_90_91, _E5_B9_B3_E5_8F_B0X_E5_BA_A7_E6_A8_99, AI_E6_A8_A1_E5_9E_8B, _E9_A0_90_E6_B8_AC_E7_B5_90_E6_9E_9C, _E7_A7_BB_E5_8B_95_E6_96_B9_E5_90_91
        _E7_99_BC_E7_90_83_E4_BD_8D_E7_BD_AE = random.randint(0 + 20, 200 - 20)
        _E7_99_BC_E7_90_83_E6_96_B9_E5_90_91 = random.randint(1, 100) % 2
